Index: src/main/resources/IRC/IRCArchiveClassTemplate.xml
===================================================================
--- src/main/resources/IRC/IRCArchiveClassTemplate.xml	(revision 33272)
+++ src/main/resources/IRC/IRCArchiveClassTemplate.xml	(working copy)
@@ -1,27 +1,26 @@
 <?xml version="1.0" encoding="UTF-8"?>
-
 <xwikidoc>
 <web>IRC</web>
 <name>IRCArchiveClassTemplate</name>
-<language></language>
+<language/>
 <defaultLanguage>en</defaultLanguage>
 <translation>0</translation>
 <parent>IRC.IRCArchiveClass</parent>
 <creator>xwiki:XWiki.LudovicDubost</creator>
 <author>XWiki.Admin</author>
-<customClass></customClass>
+<customClass/>
 <contentAuthor>XWiki.Admin</contentAuthor>
 <creationDate>1209410769000</creationDate>
-<date>1251876682000</date>
-<contentUpdateDate>1251876682000</contentUpdateDate>
+<date>1291641284000</date>
+<contentUpdateDate>1291641284000</contentUpdateDate>
 <version>1.1</version>
-<title></title>
-<template></template>
-<defaultTemplate></defaultTemplate>
-<validationScript></validationScript>
-<comment></comment>
+<title/>
+<template/>
+<defaultTemplate/>
+<validationScript/>
+<comment/>
 <minorEdit>false</minorEdit>
-<syntaxId>xwiki/1.0</syntaxId>
+<syntaxId>xwiki/2.0</syntaxId>
 <hidden>false</hidden>
-<content>#includeForm("IRC.IRCArchiveClassSheet")
-</content></xwikidoc>
\ No newline at end of file
+<content>{{include document="IRC.IRCArchiveClassSheet"/}}</content>
+</xwikidoc>
Index: src/main/resources/IRC/Translations.xml
===================================================================
--- src/main/resources/IRC/Translations.xml	(revision 0)
+++ src/main/resources/IRC/Translations.xml	(revision 0)
@@ -0,0 +1,27 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<xwikidoc>
+<web>IRC</web>
+<name>Translations</name>
+<language></language>
+<defaultLanguage>en</defaultLanguage>
+<translation>0</translation>
+<parent>IRC.WebHome</parent>
+<creator>XWiki.Admin</creator>
+<author>XWiki.Admin</author>
+<customClass></customClass>
+<contentAuthor>XWiki.Admin</contentAuthor>
+<creationDate>1291631723000</creationDate>
+<date>1291631924000</date>
+<contentUpdateDate>1291631924000</contentUpdateDate>
+<version>1.1</version>
+<title>Translations</title>
+<template></template>
+<defaultTemplate></defaultTemplate>
+<validationScript></validationScript>
+<comment></comment>
+<minorEdit>false</minorEdit>
+<syntaxId>xwiki/2.0</syntaxId>
+<hidden>false</hidden>
+<content>irc.doc.name=Name
+irc.channel=Channel
+irc.doc.date=Date </content></xwikidoc>
Index: src/main/resources/IRC/IRCBot.xml
===================================================================
--- src/main/resources/IRC/IRCBot.xml	(revision 33272)
+++ src/main/resources/IRC/IRCBot.xml	(working copy)
@@ -188,8 +188,8 @@
   * [[$item]]: $itemDoc.getValue("description")
 #end
 {{/velocity}}
-)))
 
+
 = Status =
 
 {{include document="IRC.IRCBotlet"/}}
@@ -258,8 +258,12 @@
     {
         initExecutionContext()
         def date = xwiki.formatDate(new Date(), "HH:mm", context)
-        log(channel, "${sender} - (${date}): ${message}\n")
-
+        def User[] pircUsers = this.getUsers(channel)
+        for (User singleUser in pircUsers) {
+              if (singleUser.equals(sender)){
+                     log(channel, "${date} &lt;${singleUser.getPrefix()}${sender}&gt; ${message}\n")
+                                      } 
+                }
         for (IRCBotlet botlet : Utils.getComponentManager().lookupList(IRCBotlet.class)) {
             try {
                 def result = botlet.handleMessage(channel, sender, login, hostname, message, xwiki, context)
@@ -291,21 +295,21 @@
     {
         initExecutionContext()
         def date = xwiki.formatDate(new Date(), "HH:mm", context)
-        log(channel, "${sender} joined ${channel} at ${date}\n")
+        log(channel, "${date} &lt;${sender}&gt; has joined ${channel}\n")
     }
 
     void onPart(String channel, String sender, String login, String hostname)
     {
         initExecutionContext()
         def date = xwiki.formatDate(new Date(), "HH:mm", context)
-        log(channel, "${sender} left ${channel} at ${date}\n")
+        log(channel, "${date} &lt;${sender}&gt; has left ${channel}\n")
     }
 
     void onQuit(String sourceNick, String sourceLogin, String sourceHostname, String reason)
     {
         initExecutionContext()
         def date = xwiki.formatDate(new Date(), "HH:mm", context)
-        log(getChannels()[0], "${sourceNick} left at ${date} (${reason}\n")
+        log(getChannels()[0], "${date} &lt;${sourceNick}&gt; has quit\n")
     }
 
     public void onPrivateMessage(String sender, String login, String hostname, String message)
@@ -317,7 +321,8 @@
     void onNickChange(String oldNick, String login, String hostname, String newNick)
     {
         initExecutionContext()
-        log(getChannels()[0], "${oldNick} is now known as ${newNick} (${login}@${hostname}\n")
+        def date = xwiki.formatDate(new Date(), "HH:mm", context)
+        log(getChannels()[0], "${date} &lt;${oldNick}&gt; is now known as &lt;${newNick}&gt;\n")
     }
     
     XWikiDocument getLoggingDocument(String channelName)
Index: src/main/resources/IRC/IRCConfig.xml
===================================================================
--- src/main/resources/IRC/IRCConfig.xml	(revision 33272)
+++ src/main/resources/IRC/IRCConfig.xml	(working copy)
@@ -1,5 +1,4 @@
 <?xml version="1.0" encoding="UTF-8"?>
-
 <xwikidoc>
 <web>IRC</web>
 <name>IRCConfig</name>
@@ -12,9 +11,9 @@
 <customClass></customClass>
 <contentAuthor>XWiki.Admin</contentAuthor>
 <creationDate>1266580681000</creationDate>
-<date>1266581479000</date>
-<contentUpdateDate>1266581479000</contentUpdateDate>
-<version>1.1</version>
+<date>1291373985000</date>
+<contentUpdateDate>1291373985000</contentUpdateDate>
+<version>3.1</version>
 <title>IRC Configuration</title>
 <template></template>
 <defaultTemplate></defaultTemplate>
@@ -34,6 +33,7 @@
 <nameField></nameField>
 <validationScript></validationScript>
 <botname>
+<disabled>0</disabled>
 <name>botname</name>
 <number>1</number>
 <picker>0</picker>
@@ -45,6 +45,7 @@
 <classType>com.xpn.xwiki.objects.classes.StringClass</classType>
 </botname>
 <channel>
+<disabled>0</disabled>
 <name>channel</name>
 <number>3</number>
 <picker>0</picker>
@@ -57,6 +58,7 @@
 </channel>
 <password>
 <algorithm></algorithm>
+<disabled>0</disabled>
 <name>password</name>
 <number>4</number>
 <picker>0</picker>
@@ -69,6 +71,7 @@
 <classType>com.xpn.xwiki.objects.classes.PasswordClass</classType>
 </password>
 <server>
+<disabled>0</disabled>
 <name>server</name>
 <number>2</number>
 <picker>0</picker>
@@ -80,6 +83,7 @@
 <classType>com.xpn.xwiki.objects.classes.StringClass</classType>
 </server>
 <validation>
+<disabled>0</disabled>
 <editor>PureText</editor>
 <name>validation</name>
 <number>5</number>
@@ -110,8 +114,8 @@
 <server>irc.freenode.net</server>
 </property>
 <property>
-<validation>return !source.fullName.startsWith("IRC.${bot.getChannels()[0][1..-1]}Archive")
-
+<validation>return !source.fullName.startsWith("IRC.${bot.getChannels()[0][1..-1]}Archive")
+
 </validation></property></object><object><class><name>IRC.JiraBotlet</name>
 <customClass></customClass>
 <customMapping></customMapping>
@@ -122,6 +126,7 @@
 <validationScript></validationScript>
 <jiraPassword>
 <algorithm></algorithm>
+<disabled>0</disabled>
 <name>jiraPassword</name>
 <number>3</number>
 <picker>0</picker>
@@ -134,6 +139,7 @@
 <classType>com.xpn.xwiki.objects.classes.PasswordClass</classType>
 </jiraPassword>
 <jiraPattern>
+<disabled>0</disabled>
 <name>jiraPattern</name>
 <number>4</number>
 <picker>0</picker>
@@ -145,6 +151,7 @@
 <classType>com.xpn.xwiki.objects.classes.StringClass</classType>
 </jiraPattern>
 <jiraURL>
+<disabled>0</disabled>
 <name>jiraURL</name>
 <number>1</number>
 <picker>0</picker>
@@ -156,6 +163,7 @@
 <classType>com.xpn.xwiki.objects.classes.StringClass</classType>
 </jiraURL>
 <jiraUsername>
+<disabled>0</disabled>
 <name>jiraUsername</name>
 <number>2</number>
 <picker>0</picker>
@@ -196,6 +204,7 @@
 <validationScript></validationScript>
 <wikis>
 <cache>0</cache>
+<disabled>0</disabled>
 <displayType>input</displayType>
 <multiSelect>0</multiSelect>
 <name>wikis</name>
@@ -224,5 +233,4 @@
 </object>
 <content>This page contains the IRC Bot configuration + all Botlet configurations too, stored as XWiki Objects. To modify the IRC Application configuration just edit this page's objects.
 
-{{warning}}When you uprgade the IRC Application, don't overwrite this page since it'll have your specific configuration.{{/warning}}</content>
-</xwikidoc>
+{{warning}}When you uprgade the IRC Application, don't overwrite this page since it'll have your specific configuration.{{/warning}}</content></xwikidoc>
Index: src/main/resources/IRC/WikiSearchBotlet.xml
===================================================================
--- src/main/resources/IRC/WikiSearchBotlet.xml	(revision 33272)
+++ src/main/resources/IRC/WikiSearchBotlet.xml	(working copy)
@@ -1,5 +1,4 @@
 <?xml version="1.0" encoding="UTF-8"?>
-
 <xwikidoc>
 <web>IRC</web>
 <name>WikiSearchBotlet</name>
@@ -34,6 +33,7 @@
 <nameField></nameField>
 <validationScript></validationScript>
 <description>
+<disabled>0</disabled>
 <name>description</name>
 <number>1</number>
 <picker>0</picker>
@@ -45,6 +45,7 @@
 <classType>com.xpn.xwiki.objects.classes.StringClass</classType>
 </description>
 <usage>
+<disabled>0</disabled>
 <name>usage</name>
 <number>2</number>
 <picker>0</picker>
@@ -79,6 +80,7 @@
 <validationScript></validationScript>
 <allow>
 <defaultValue>1</defaultValue>
+<disabled>0</disabled>
 <displayFormType>select</displayFormType>
 <displayType>allow</displayType>
 <name>allow</name>
@@ -89,6 +91,7 @@
 </allow>
 <groups>
 <cache>0</cache>
+<disabled>0</disabled>
 <displayType>select</displayType>
 <multiSelect>1</multiSelect>
 <name>groups</name>
@@ -103,6 +106,7 @@
 </groups>
 <levels>
 <cache>0</cache>
+<disabled>0</disabled>
 <displayType>select</displayType>
 <multiSelect>1</multiSelect>
 <name>levels</name>
@@ -116,6 +120,7 @@
 </levels>
 <users>
 <cache>0</cache>
+<disabled>0</disabled>
 <displayType>select</displayType>
 <multiSelect>1</multiSelect>
 <name>users</name>
@@ -240,5 +245,4 @@
 
 // Pretty print the first Groovy macro content.
 println "{{code language=\"none\"}}${doc.getDocument().getXDOM().getChildrenByType(MacroBlock.class, true).get(2).getContent()}{{/code}}"
-{{/groovy}}</content>
-</xwikidoc>
+{{/groovy}}</content></xwikidoc>
Index: src/main/resources/IRC/IRCArchiveClass.xml
===================================================================
--- src/main/resources/IRC/IRCArchiveClass.xml	(revision 33272)
+++ src/main/resources/IRC/IRCArchiveClass.xml	(working copy)
@@ -1,68 +1,73 @@
 <?xml version="1.0" encoding="UTF-8"?>
-
 <xwikidoc>
 <web>IRC</web>
 <name>IRCArchiveClass</name>
-<language></language>
+<language/>
 <defaultLanguage>en</defaultLanguage>
 <translation>0</translation>
 <parent>XWiki.XWikiClasses</parent>
 <creator>xwiki:XWiki.LudovicDubost</creator>
 <author>XWiki.Admin</author>
-<customClass></customClass>
-<contentAuthor>xwiki:XWiki.LudovicDubost</contentAuthor>
+<customClass/>
+<contentAuthor>XWiki.Admin</contentAuthor>
 <creationDate>1209410670000</creationDate>
-<date>1209410760000</date>
-<contentUpdateDate>1209410726000</contentUpdateDate>
+<date>1291641673000</date>
+<contentUpdateDate>1291641673000</contentUpdateDate>
 <version>1.1</version>
-<title></title>
-<template></template>
-<defaultTemplate></defaultTemplate>
-<validationScript></validationScript>
-<comment></comment>
+<title/>
+<template/>
+<defaultTemplate/>
+<validationScript/>
+<comment/>
 <minorEdit>false</minorEdit>
-<syntaxId>xwiki/1.0</syntaxId>
+<syntaxId>xwiki/2.0</syntaxId>
 <hidden>false</hidden>
 <class>
 <name>IRC.IRCArchiveClass</name>
-<customClass></customClass>
-<customMapping></customMapping>
-<defaultViewSheet></defaultViewSheet>
-<defaultEditSheet></defaultEditSheet>
-<defaultWeb></defaultWeb>
-<nameField></nameField>
-<validationScript></validationScript>
+<customClass/>
+<customMapping/>
+<defaultViewSheet/>
+<defaultEditSheet/>
+<defaultWeb/>
+<nameField/>
+<validationScript/>
 <channel>
-<customDisplay></customDisplay>
+<customDisplay/>
+<disabled>0</disabled>
 <name>channel</name>
 <number>2</number>
-<picker></picker>
+<picker/>
 <prettyName>channel</prettyName>
 <size>30</size>
-<tooltip></tooltip>
+<tooltip/>
 <unmodifiable>0</unmodifiable>
-<validationMessage></validationMessage>
-<validationRegExp></validationRegExp>
+<validationMessage/>
+<validationRegExp/>
 <classType>com.xpn.xwiki.objects.classes.StringClass</classType>
 </channel>
 <content>
 <contenttype>PureText</contenttype>
-<customDisplay></customDisplay>
+<customDisplay/>
+<disabled>0</disabled>
 <editor>---</editor>
 <name>content</name>
 <number>1</number>
-<picker></picker>
+<picker/>
 <prettyName>content</prettyName>
 <rows>5</rows>
 <size>40</size>
-<tooltip></tooltip>
+<tooltip/>
 <unmodifiable>0</unmodifiable>
-<validationMessage></validationMessage>
-<validationRegExp></validationRegExp>
+<validationMessage/>
+<validationRegExp/>
 <classType>com.xpn.xwiki.objects.classes.TextAreaClass</classType>
 </content>
 </class>
-<content>#set($defaultparent = "IRC.WebHome")
+−
+<content>
+{{velocity filter="none"}}
+#set($defaultparent = "IRC.WebHome")
 #set($defaultweb = "IRC")
-#includeForm("XWiki.ClassSheet")</content>
+{{/velocity}}{{include document="XWiki.ClassSheet"/}}
+</content>
 </xwikidoc>
Index: src/main/resources/IRC/WebHome.xml
===================================================================
--- src/main/resources/IRC/WebHome.xml	(revision 33272)
+++ src/main/resources/IRC/WebHome.xml	(working copy)
@@ -1,5 +1,4 @@
 <?xml version="1.0" encoding="UTF-8"?>
-
 <xwikidoc>
 <web>IRC</web>
 <name>WebHome</name>
@@ -12,8 +11,8 @@
 <customClass></customClass>
 <contentAuthor>XWiki.Admin</contentAuthor>
 <creationDate>1251823498000</creationDate>
-<date>1254066318000</date>
-<contentUpdateDate>1254066318000</contentUpdateDate>
+<date>1291632501000</date>
+<contentUpdateDate>1291632501000</contentUpdateDate>
 <version>1.1</version>
 <title>IRC</title>
 <template></template>
@@ -38,8 +37,9 @@
 })
 #set($options = {
    "className":"IRC.IRCArchiveClass",
+    "translationPrefix" : "irc.",
    "rowCount": 10
 })
 #livetable("ircarchives" $columns $columnsProperties $options)
 {{/velocity}}
-</content></xwikidoc>
\ No newline at end of file
+</content></xwikidoc>
Index: src/main/resources/IRC/IRCBotlet.xml
===================================================================
--- src/main/resources/IRC/IRCBotlet.xml	(revision 33272)
+++ src/main/resources/IRC/IRCBotlet.xml	(working copy)
@@ -1,5 +1,4 @@
 <?xml version="1.0" encoding="UTF-8"?>
-
 <xwikidoc>
 <web>IRC</web>
 <name>IRCBotlet</name>
@@ -19,8 +18,8 @@
 <template></template>
 <defaultTemplate></defaultTemplate>
 <validationScript></validationScript>
-<comment>allow delete right for XWiki.XWikiAdminGroup</comment>
-<minorEdit>true</minorEdit>
+<comment></comment>
+<minorEdit>false</minorEdit>
 <syntaxId>xwiki/2.0</syntaxId>
 <hidden>false</hidden>
 <class>
@@ -33,6 +32,7 @@
 <nameField></nameField>
 <validationScript></validationScript>
 <description>
+<disabled>0</disabled>
 <name>description</name>
 <number>1</number>
 <picker>0</picker>
@@ -44,6 +44,7 @@
 <classType>com.xpn.xwiki.objects.classes.StringClass</classType>
 </description>
 <usage>
+<disabled>0</disabled>
 <name>usage</name>
 <number>2</number>
 <picker>0</picker>
@@ -67,6 +68,7 @@
 <validationScript></validationScript>
 <allow>
 <defaultValue>1</defaultValue>
+<disabled>0</disabled>
 <displayFormType>select</displayFormType>
 <displayType>allow</displayType>
 <name>allow</name>
@@ -77,6 +79,7 @@
 </allow>
 <groups>
 <cache>0</cache>
+<disabled>0</disabled>
 <displayType>select</displayType>
 <multiSelect>1</multiSelect>
 <name>groups</name>
@@ -91,6 +94,7 @@
 </groups>
 <levels>
 <cache>0</cache>
+<disabled>0</disabled>
 <displayType>select</displayType>
 <multiSelect>1</multiSelect>
 <name>levels</name>
@@ -104,6 +108,7 @@
 </levels>
 <users>
 <cache>0</cache>
+<disabled>0</disabled>
 <displayType>select</displayType>
 <multiSelect>1</multiSelect>
 <name>users</name>
@@ -139,5 +144,4 @@
     List handleMessage(String channel, String sender, String login, String hostname, String message, XWiki xwiki, XWikiContext context)
 }
 def dummy
-{{/groovy}}</content>
-</xwikidoc>
+{{/groovy}}</content></xwikidoc>
Index: src/main/resources/IRC/Admin.xml
===================================================================
--- src/main/resources/IRC/Admin.xml	(revision 33272)
+++ src/main/resources/IRC/Admin.xml	(working copy)
@@ -1,5 +1,4 @@
 <?xml version="1.0" encoding="UTF-8"?>
-
 <xwikidoc>
 <web>IRC</web>
 <name>Admin</name>
@@ -46,5 +45,4 @@
 #else
   You must be admin to perform IRC Bot actions.
 #end
-{{/velocity}}</content>
-</xwikidoc>
+{{/velocity}}</content></xwikidoc>
Index: src/main/resources/IRC/WikiNewsBotlet.xml
===================================================================
--- src/main/resources/IRC/WikiNewsBotlet.xml	(revision 33272)
+++ src/main/resources/IRC/WikiNewsBotlet.xml	(working copy)
@@ -1,5 +1,4 @@
 <?xml version="1.0" encoding="UTF-8"?>
-
 <xwikidoc>
 <web>IRC</web>
 <name>WikiNewsBotlet</name>
@@ -34,6 +33,7 @@
 <validationScript></validationScript>
 <wikis>
 <cache>0</cache>
+<disabled>0</disabled>
 <displayType>input</displayType>
 <multiSelect>0</multiSelect>
 <name>wikis</name>
@@ -63,6 +63,7 @@
 <nameField></nameField>
 <validationScript></validationScript>
 <description>
+<disabled>0</disabled>
 <name>description</name>
 <number>1</number>
 <picker>0</picker>
@@ -74,6 +75,7 @@
 <classType>com.xpn.xwiki.objects.classes.StringClass</classType>
 </description>
 <usage>
+<disabled>0</disabled>
 <name>usage</name>
 <number>2</number>
 <picker>0</picker>
@@ -108,6 +110,7 @@
 <validationScript></validationScript>
 <allow>
 <defaultValue>1</defaultValue>
+<disabled>0</disabled>
 <displayFormType>select</displayFormType>
 <displayType>allow</displayType>
 <name>allow</name>
@@ -118,6 +121,7 @@
 </allow>
 <groups>
 <cache>0</cache>
+<disabled>0</disabled>
 <displayType>select</displayType>
 <multiSelect>1</multiSelect>
 <name>groups</name>
@@ -132,6 +136,7 @@
 </groups>
 <levels>
 <cache>0</cache>
+<disabled>0</disabled>
 <displayType>select</displayType>
 <multiSelect>1</multiSelect>
 <name>levels</name>
@@ -145,6 +150,7 @@
 </levels>
 <users>
 <cache>0</cache>
+<disabled>0</disabled>
 <displayType>select</displayType>
 <multiSelect>1</multiSelect>
 <name>users</name>
@@ -338,5 +344,4 @@
 
 // Pretty print the first Groovy macro content.
 println "{{code language=\"none\"}}${doc.getDocument().getXDOM().getChildrenByType(MacroBlock.class, true).get(2).getContent()}{{/code}}"
-{{/groovy}}</content>
-</xwikidoc>
+{{/groovy}}</content></xwikidoc>
Index: src/main/resources/IRC/IRCArchiveClassSheet.xml
===================================================================
--- src/main/resources/IRC/IRCArchiveClassSheet.xml	(revision 33272)
+++ src/main/resources/IRC/IRCArchiveClassSheet.xml	(working copy)
@@ -1,5 +1,4 @@
 <?xml version="1.0" encoding="UTF-8"?>
-
 <xwikidoc>
 <web>IRC</web>
 <name>IRCArchiveClassSheet</name>
@@ -12,21 +11,19 @@
 <customClass></customClass>
 <contentAuthor>XWiki.Admin</contentAuthor>
 <creationDate>1209410769000</creationDate>
-<date>1251976169000</date>
-<contentUpdateDate>1251976169000</contentUpdateDate>
-<version>1.1</version>
+<date>1291383123000</date>
+<contentUpdateDate>1291383123000</contentUpdateDate>
+<version>4.1</version>
 <title></title>
 <template></template>
 <defaultTemplate></defaultTemplate>
 <validationScript></validationScript>
 <comment></comment>
 <minorEdit>false</minorEdit>
-<syntaxId>xwiki/1.0</syntaxId>
+<syntaxId>xwiki/2.0</syntaxId>
 <hidden>false</hidden>
-<content>$doc.use("IRC.IRCArchiveClass")
-{pre}
-&lt;pre&gt;
-$xwiki.getXMLEncoded($doc.display("content"))
-&lt;/pre&gt;
-{/pre}</content>
-</xwikidoc>
+<content>{{velocity filter="none"}}
+{{code language="irc"}}
+$doc.getObject("IRC.IRCArchiveClass").getProperty("content").getValue()
+{{/code}}
+{{/velocity}}</content></xwikidoc>
Index: src/main/resources/IRC/JiraBotlet.xml
===================================================================
--- src/main/resources/IRC/JiraBotlet.xml	(revision 33272)
+++ src/main/resources/IRC/JiraBotlet.xml	(working copy)
@@ -1,5 +1,4 @@
 <?xml version="1.0" encoding="UTF-8"?>
-
 <xwikidoc>
 <web>IRC</web>
 <name>JiraBotlet</name>
@@ -34,6 +33,7 @@
 <validationScript></validationScript>
 <jiraPassword>
 <algorithm></algorithm>
+<disabled>0</disabled>
 <name>jiraPassword</name>
 <number>3</number>
 <picker>0</picker>
@@ -46,6 +46,7 @@
 <classType>com.xpn.xwiki.objects.classes.PasswordClass</classType>
 </jiraPassword>
 <jiraPattern>
+<disabled>0</disabled>
 <name>jiraPattern</name>
 <number>4</number>
 <picker>0</picker>
@@ -57,6 +58,7 @@
 <classType>com.xpn.xwiki.objects.classes.StringClass</classType>
 </jiraPattern>
 <jiraURL>
+<disabled>0</disabled>
 <name>jiraURL</name>
 <number>1</number>
 <picker>0</picker>
@@ -68,6 +70,7 @@
 <classType>com.xpn.xwiki.objects.classes.StringClass</classType>
 </jiraURL>
 <jiraUsername>
+<disabled>0</disabled>
 <name>jiraUsername</name>
 <number>2</number>
 <picker>0</picker>
@@ -90,6 +93,7 @@
 <nameField></nameField>
 <validationScript></validationScript>
 <description>
+<disabled>0</disabled>
 <name>description</name>
 <number>1</number>
 <picker>0</picker>
@@ -101,6 +105,7 @@
 <classType>com.xpn.xwiki.objects.classes.StringClass</classType>
 </description>
 <usage>
+<disabled>0</disabled>
 <name>usage</name>
 <number>2</number>
 <picker>0</picker>
@@ -135,6 +140,7 @@
 <validationScript></validationScript>
 <jiraPassword>
 <algorithm></algorithm>
+<disabled>0</disabled>
 <name>jiraPassword</name>
 <number>3</number>
 <picker>0</picker>
@@ -147,6 +153,7 @@
 <classType>com.xpn.xwiki.objects.classes.PasswordClass</classType>
 </jiraPassword>
 <jiraPattern>
+<disabled>0</disabled>
 <name>jiraPattern</name>
 <number>4</number>
 <picker>0</picker>
@@ -158,6 +165,7 @@
 <classType>com.xpn.xwiki.objects.classes.StringClass</classType>
 </jiraPattern>
 <jiraURL>
+<disabled>0</disabled>
 <name>jiraURL</name>
 <number>1</number>
 <picker>0</picker>
@@ -169,6 +177,7 @@
 <classType>com.xpn.xwiki.objects.classes.StringClass</classType>
 </jiraURL>
 <jiraUsername>
+<disabled>0</disabled>
 <name>jiraUsername</name>
 <number>2</number>
 <picker>0</picker>
@@ -209,6 +218,7 @@
 <validationScript></validationScript>
 <allow>
 <defaultValue>1</defaultValue>
+<disabled>0</disabled>
 <displayFormType>select</displayFormType>
 <displayType>allow</displayType>
 <name>allow</name>
@@ -219,6 +229,7 @@
 </allow>
 <groups>
 <cache>0</cache>
+<disabled>0</disabled>
 <displayType>select</displayType>
 <multiSelect>1</multiSelect>
 <name>groups</name>
@@ -233,6 +244,7 @@
 </groups>
 <levels>
 <cache>0</cache>
+<disabled>0</disabled>
 <displayType>select</displayType>
 <multiSelect>1</multiSelect>
 <name>levels</name>
@@ -246,6 +258,7 @@
 </levels>
 <users>
 <cache>0</cache>
+<disabled>0</disabled>
 <displayType>select</displayType>
 <multiSelect>1</multiSelect>
 <name>users</name>
@@ -423,5 +436,4 @@
 
 // Pretty print the first Groovy macro content.
 println "{{code language=\"none\"}}${doc.getDocument().getXDOM().getChildrenByType(MacroBlock.class, true).get(2).getContent()}{{/code}}"
-{{/groovy}}</content>
-</xwikidoc>
+{{/groovy}}</content></xwikidoc>