Index: src/test/it/org/xwiki/test/ui/UserProfileTest.java
===================================================================
--- src/test/it/org/xwiki/test/ui/UserProfileTest.java	(revision 33838)
+++ src/test/it/org/xwiki/test/ui/UserProfileTest.java	(working copy)
@@ -28,6 +28,7 @@
 import org.xwiki.test.ui.framework.AbstractAdminAuthenticatedTest;
 import org.xwiki.test.ui.framework.elements.PreferencesPage;
 import org.xwiki.test.ui.framework.elements.ProfilePage;
+import org.xwiki.test.ui.framework.elements.ViewPage;
 import org.xwiki.test.ui.framework.elements.editor.ChangeAvatarPage;
 import org.xwiki.test.ui.framework.elements.editor.ChangePasswordPage;
 import org.xwiki.test.ui.framework.elements.editor.PreferencesEditPage;
@@ -58,6 +59,8 @@
 
     private static final String USER_BLOGFEED = "http://xwiki.org/";
 
+    private static final String COMMENT_CONTENT = "this is from a comment";
+
     private ProfilePage profilePage = new ProfilePage();
 
     /** Functionality check: changing profile information. */
@@ -214,4 +217,26 @@
         Assert.assertFalse(about.isDisplayed());
         Assert.assertTrue(getDriver().findElement(By.className("xRichTextEditor")) != null);
     }
+
+    /**
+     * Check that the content of the first comment isn't used as the "About" information in the user profile. See
+     * XAADMINISTRATION-157.
+     */
+    @Test
+    public void testCommentDoesntOverrideAboutInformation()
+    {
+
+        ViewPage profile = this.getUtil().gotoPage("XWiki", "Admin");
+        int commentId = -1;
+        try {
+            commentId = profile.openCommentsDocExtraPane().postComment(COMMENT_CONTENT);
+            getDriver().navigate().refresh();
+            Assert.assertFalse("Comment content was used as profile information",
+                profile.getContent().contains(COMMENT_CONTENT));
+        } finally {
+            if (commentId != -1) {
+                profile.openCommentsDocExtraPane().deleteComment(commentId);
+            }
+        }
+    }
 }
Index: src/test/it/org/xwiki/test/ui/administration/UserProfileTest.java
===================================================================
--- src/test/it/org/xwiki/test/ui/administration/UserProfileTest.java	(revision 33838)
+++ src/test/it/org/xwiki/test/ui/administration/UserProfileTest.java	(working copy)
@@ -1,57 +0,0 @@
-/*
- * See the NOTICE file distributed with this work for additional
- * information regarding copyright ownership.
- *
- * This is free software; you can redistribute it and/or modify it
- * under the terms of the GNU Lesser General Public License as
- * published by the Free Software Foundation; either version 2.1 of
- * the License, or (at your option) any later version.
- *
- * This software is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
- * Lesser General Public License for more details.
- *
- * You should have received a copy of the GNU Lesser General Public
- * License along with this software; if not, write to the Free
- * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
- * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
- */
-package org.xwiki.test.ui.administration;
-
-import junit.framework.Assert;
-
-import org.junit.Test;
-import org.xwiki.test.ui.framework.AbstractAdminAuthenticatedTest;
-import org.xwiki.test.ui.framework.elements.ViewPage;
-
-/**
- * Test the user profile.
- * 
- * @version $Id$
- * @since 2.4
- */
-public class UserProfileTest extends AbstractAdminAuthenticatedTest
-{
-    /**
-     * Check that the content of the first comment isn't used as the "About" information in the user profile. See
-     * XAADMINISTRATION-157.
-     */
-    @Test
-    public void testCommentDoesntOverrideAboutInformation()
-    {
-        String commentContent = "this is from a comment";
-        ViewPage profile = this.getUtil().gotoPage("XWiki", "Admin");
-        int commentId = -1;
-        try {
-            commentId = profile.openCommentsDocExtraPane().postComment(commentContent);
-            getDriver().navigate().refresh();
-            Assert.assertFalse("Comment content was used as profile information",
-                profile.getContent().contains(commentContent));
-        } finally {
-            if (commentId != -1) {
-                profile.openCommentsDocExtraPane().deleteComment(commentId);
-            }
-        }
-    }
-}
Index: src/test/it/org/xwiki/test/ui/framework/elements/ViewPage.java
===================================================================
--- src/test/it/org/xwiki/test/ui/framework/elements/ViewPage.java	(revision 33838)
+++ src/test/it/org/xwiki/test/ui/framework/elements/ViewPage.java	(working copy)
@@ -37,16 +37,16 @@
  */
 public class ViewPage extends BasePage
 {
-    @FindBys( {@FindBy(id = "tmRegister"), @FindBy(tagName = "a")})
+    @FindBys({@FindBy(id = "tmRegister"), @FindBy(tagName = "a")})
     private WebElement registerLink;
 
-    @FindBys( {@FindBy(id = "tmLogin"), @FindBy(tagName = "a")})
+    @FindBys({@FindBy(id = "tmLogin"), @FindBy(tagName = "a")})
     private WebElement loginLink;
 
-    @FindBys( {@FindBy(id = "tmLogout"), @FindBy(tagName = "a")})
+    @FindBys({@FindBy(id = "tmLogout"), @FindBy(tagName = "a")})
     private WebElement logoutLink;
 
-    @FindBys( {@FindBy(id = "tmUser"), @FindBy(tagName = "a")})
+    @FindBys({@FindBy(id = "tmUser"), @FindBy(tagName = "a")})
     private WebElement userLink;
 
     @FindBy(id = "tmCreatePage")
@@ -221,13 +221,15 @@
 
     /**
      * Clicks on a wanted link in the page.
-     *
+     * 
      * @since 2.6RC1
      */
     public void clickWantedLink(String spaceName, String pageName, boolean waitForTemplateDisplay)
     {
-        WebElement brokenLink = getDriver().findElement(By.xpath(
-            "//span[@class='wikicreatelink']/a[contains(@href,'/create/" + spaceName + "/" + pageName + "')]"));
+        WebElement brokenLink =
+            getDriver().findElement(
+                By.xpath("//span[@class='wikicreatelink']/a[contains(@href,'/create/" + spaceName + "/" + pageName
+                    + "')]"));
         brokenLink.click();
         if (waitForTemplateDisplay) {
             // Ensure that the template choice popup is displayed. Since this is done using JS we need to wait till