Index: selenium-tests/src/test/it/org/xwiki/test/selenium/UserProfileTest.java
===================================================================
--- selenium-tests/src/test/it/org/xwiki/test/selenium/UserProfileTest.java	(revision 33841)
+++ selenium-tests/src/test/it/org/xwiki/test/selenium/UserProfileTest.java	(working copy)
@@ -1,80 +0,0 @@
-/*
- * See the NOTICE file distributed with this work for additional
- * information regarding copyright ownership.
- *
- * This is free software; you can redistribute it and/or modify it
- * under the terms of the GNU Lesser General Public License as
- * published by the Free Software Foundation; either version 2.1 of
- * the License, or (at your option) any later version.
- *
- * This software is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
- * Lesser General Public License for more details.
- *
- * You should have received a copy of the GNU Lesser General Public
- * License along with this software; if not, write to the Free
- * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
- * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
- */
-package org.xwiki.test.selenium;
-
-import junit.framework.Test;
-
-import org.xwiki.test.selenium.framework.AbstractXWikiTestCase;
-import org.xwiki.test.selenium.framework.ColibriSkinExecutor;
-import org.xwiki.test.selenium.framework.XWikiTestSuite;
-
-/**
- * Different user profile tests.
- * 
- * @version $Id$
- */
-public class UserProfileTest extends AbstractXWikiTestCase
-{
-    public static Test suite()
-    {
-        XWikiTestSuite suite = new XWikiTestSuite("Different user profile tests");
-        suite.addTestSuite(UserProfileTest.class, ColibriSkinExecutor.class);
-        return suite;
-    }
-
-    @Override
-    public void setUp() throws Exception
-    {
-        super.setUp();
-        loginAsAdmin();
-    }
-
-    public void testChangePasswordWithTwoDifferentPasswords()
-    {
-        open("XWiki", "Admin");
-        clickLinkWithText("Change password");
-        setFieldValue("xwikipassword", "p1");
-        setFieldValue("xwikipassword2", "p2");
-        clickLinkWithXPath("//input[@type='submit']", false);
-        assertTrue(getSelenium().isAlertPresent());
-        assertEquals("The two passwords do not match.", getSelenium().getAlert());
-    }
-
-    public void testChangePasswordWithoutEnteringPasswords()
-    {
-        open("XWiki", "Admin");
-        clickLinkWithText("Change password");
-        clickLinkWithXPath("//input[@type='submit']", false);
-        assertTrue(getSelenium().isAlertPresent());
-        assertEquals("The password cannot be empty.", getSelenium().getAlert());
-    }
-
-    public void testChangePasswordOfAnotherUserWithTwoDifferentPasswords()
-    {
-        open("XWiki", "Register", "register", "register_first_name=Test&register_last_name=User&xwikiname=TestUser"
-            + "&register_password=test&register2_password=test&register_email=test@test.com"
-            + "&template=XWiki.XWikiUserTemplate&register=1");
-        open("XWiki", "TestUser");
-        clickLinkWithText("Change password");
-        clickLinkWithXPath("//input[@type='submit']", false);
-        assertTrue(getSelenium().isAlertPresent());
-        assertEquals("The password cannot be empty.", getSelenium().getAlert());
-    }
-}
Index: selenium-tests/src/test/it/org/xwiki/test/selenium/CopyPageTest.java
===================================================================
--- selenium-tests/src/test/it/org/xwiki/test/selenium/CopyPageTest.java	(revision 33841)
+++ selenium-tests/src/test/it/org/xwiki/test/selenium/CopyPageTest.java	(working copy)
@@ -1,61 +0,0 @@
-/*
- * See the NOTICE file distributed with this work for additional
- * information regarding copyright ownership.
- *
- * This is free software; you can redistribute it and/or modify it
- * under the terms of the GNU Lesser General Public License as
- * published by the Free Software Foundation; either version 2.1 of
- * the License, or (at your option) any later version.
- *
- * This software is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
- * Lesser General Public License for more details.
- *
- * You should have received a copy of the GNU Lesser General Public
- * License along with this software; if not, write to the Free
- * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
- * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
- */
-package org.xwiki.test.selenium;
-
-import org.xwiki.test.selenium.framework.AbstractXWikiTestCase;
-import org.xwiki.test.selenium.framework.ColibriSkinExecutor;
-import org.xwiki.test.selenium.framework.XWikiTestSuite;
-import junit.framework.Test;
-
-/**
- * Verify the copy document feature.
- *
- * @version $Id$
- */
-public class CopyPageTest extends AbstractXWikiTestCase
-{
-    public static Test suite()
-    {
-        XWikiTestSuite suite = new XWikiTestSuite("Verify the copy document feature");
-        suite.addTestSuite(CopyPageTest.class, ColibriSkinExecutor.class);
-        return suite;
-    }
-
-    public void setUp() throws Exception
-    {
-        super.setUp();
-        loginAsAdmin();
-    }
-
-    public void testCopyPage()
-    {
-        createPage("Test", "CopyTest1", "some content");
-        clickCopyPage();
-
-        getSelenium().type("targetdoc", "Test.CopyTest2");
-        clickLinkWithLocator("//input[@value='Copy']");
-
-        assertTextPresent("successfully copied to");
-        clickLinkWithText("Test.CopyTest2");
-        
-        assertPage("Test", "CopyTest2");
-        assertTextPresent("some content");
-    }
-}
Index: selenium-tests/src/test/it/org/xwiki/test/selenium/AllTests.java
===================================================================
--- selenium-tests/src/test/it/org/xwiki/test/selenium/AllTests.java	(revision 33841)
+++ selenium-tests/src/test/it/org/xwiki/test/selenium/AllTests.java	(working copy)
@@ -26,7 +26,6 @@
 import junit.framework.TestSuite;
 
 import org.xwiki.test.XWikiTestSetup;
-
 import org.xwiki.test.selenium.framework.AbstractXWikiTestCase;
 import org.xwiki.test.selenium.framework.XWikiSeleniumTestSetup;
 
@@ -53,7 +52,6 @@
 
         addTestCase(suite, DeletePageTest.class);
         addTestCase(suite, LoginLogoutTest.class);
-        addTestCase(suite, UserProfileTest.class);
         addTestCase(suite, WikiEditorTest.class);
         addTestCase(suite, WysiwygEditorFromWikiTest.class);
         addTestCase(suite, WysiwygEditorTest.class);
@@ -67,7 +65,6 @@
         addTestCase(suite, AllDocsTest.class);
         addTestCase(suite, UrlMiscTest.class);
         addTestCase(suite, ValidationTest.class);
-        addTestCase(suite, CopyPageTest.class);
         addTestCase(suite, AdministrationTest.class);
         addTestCase(suite, SchedulerTest.class);
         // Watchlist tests must be executed after scheduler tests since they rely on the scheduler.
Index: ui-tests/src/test/it/org/xwiki/test/ui/administration/UserProfileTest.java
===================================================================
--- ui-tests/src/test/it/org/xwiki/test/ui/administration/UserProfileTest.java	(revision 34205)
+++ ui-tests/src/test/it/org/xwiki/test/ui/administration/UserProfileTest.java	(working copy)
@@ -25,6 +25,7 @@
 import org.apache.commons.lang.StringUtils;
 import org.junit.Before;
 import org.junit.Test;
+import org.openqa.selenium.Alert;
 import org.xwiki.test.ui.administration.elements.PreferencesUserProfilePage;
 import org.xwiki.test.ui.administration.elements.ProfileUserProfilePage;
 import org.xwiki.test.ui.framework.AbstractTest;
@@ -75,6 +76,14 @@
 
     private static final String ADVANCED_USER = "Advanced";
 
+    private static final String PASSWORD_IS_EMPTY = "The password cannot be empty.";
+
+    private static final String PASSWORD_MISMATCH = "The two passwords do not match.";
+
+    private static final String PASSWORD_1 = "p1";
+
+    private static final String PASSWORD_2 = "p2";
+
     private ProfileUserProfilePage customProfilePage;
 
     private String userName;
@@ -111,8 +120,8 @@
         Assert.assertEquals(USER_COMPANY, customProfilePage.getUserCompany());
         Assert.assertEquals(USER_ABOUT, customProfilePage.getUserAbout());
         // The page will show webmaster@---- for security reasons, just check the first part of the email
-        Assert.assertEquals(StringUtils.substringBefore(USER_EMAIL, "@"), StringUtils.substringBefore(customProfilePage
-            .getUserEmail(), "@"));
+        Assert.assertEquals(StringUtils.substringBefore(USER_EMAIL, "@"),
+            StringUtils.substringBefore(customProfilePage.getUserEmail(), "@"));
         Assert.assertEquals(USER_PHONE, customProfilePage.getUserPhone());
         Assert.assertEquals(USER_ADDRESS, customProfilePage.getUserAddress());
         Assert.assertEquals(USER_BLOG, customProfilePage.getUserBlog());
@@ -213,15 +222,59 @@
         String commentContent = "this is from a comment";
         ViewPage profile = this.getUtil().gotoPage("XWiki", userName);
         int commentId = -1;
-        try {
-            commentId = profile.openCommentsDocExtraPane().postComment(commentContent);
-            getDriver().navigate().refresh();
-            Assert.assertFalse("Comment content was used as profile information", profile.getContent().contains(
-                commentContent));
-        } finally {
-            if (commentId != -1) {
-                profile.openCommentsDocExtraPane().deleteComment(commentId);
-            }
+
+        commentId = profile.openCommentsDocExtraPane().postComment(commentContent);
+        getDriver().navigate().refresh();
+        Assert.assertFalse("Comment content was used as profile information",
+            profile.getContent().contains(commentContent));
+
+        if (commentId != -1) {
+            profile.openCommentsDocExtraPane().deleteComment(commentId);
         }
     }
+
+    @Test
+    public void testChangePasswordWithTwoDifferentPasswords()
+    {
+        this.customProfilePage.gotoPage();
+        PreferencesUserProfilePage preferencesPage = this.customProfilePage.switchToPreferences();
+        ChangePasswordPage changePasswordPage = preferencesPage.changePassword();
+        changePasswordPage.changePassword(PASSWORD_1, PASSWORD_2);
+        changePasswordPage.submit();
+        Alert alert = getDriver().switchTo().alert();
+        Assert.assertEquals(PASSWORD_MISMATCH, alert.getText());
+        alert.accept();
+    }
+
+    @Test
+    public void testChangePasswordWithoutEnteringPasswords()
+    {
+        PreferencesUserProfilePage preferencesPage = this.customProfilePage.switchToPreferences();
+        ChangePasswordPage changePasswordPage = preferencesPage.changePassword();
+        // changePasswordPage.changePassword(PASSWORD_1, PASSWORD_2);
+        changePasswordPage.submit();
+        Alert alert = getDriver().switchTo().alert();
+        Assert.assertEquals(PASSWORD_IS_EMPTY, alert.getText());
+        alert.accept();
+    }
+
+    public void testChangePasswordOfAnotherUserWithTwoDifferentPasswords()
+    {
+        // Logout
+        getUtil().setSession(null);
+        HomePage home = new HomePage();
+        home.gotoPage();
+        Assert.assertFalse(home.isAuthenticated());
+        // Login as Admin and change the password of another user
+        getDriver().get(getUtil().getURLToLoginAs("Admin", "admin"));
+        Assert.assertTrue(home.isAuthenticated());
+        customProfilePage.gotoPage();
+        PreferencesUserProfilePage preferencesPage = this.customProfilePage.switchToPreferences();
+        ChangePasswordPage changePasswordPage = preferencesPage.changePassword();
+        changePasswordPage.changePassword(PASSWORD_1, PASSWORD_2);
+        changePasswordPage.submit();
+        Alert alert = getDriver().switchTo().alert();
+        Assert.assertEquals(PASSWORD_MISMATCH, alert.getText());
+        alert.accept();
+    }
 }
Index: ui-tests/src/test/it/org/xwiki/test/ui/administration/elements/AbstractUserProfilePage.java
===================================================================
--- ui-tests/src/test/it/org/xwiki/test/ui/administration/elements/AbstractUserProfilePage.java	(revision 34205)
+++ ui-tests/src/test/it/org/xwiki/test/ui/administration/elements/AbstractUserProfilePage.java	(working copy)
@@ -50,6 +50,11 @@
         this.targetUsername = username;
     }
 
+    public String getTargetUsername()
+    {
+        return this.targetUsername;
+    }
+
     public PreferencesUserProfilePage switchToPreferences()
     {
         this.preferences.click();
Index: ui-tests/src/test/it/org/xwiki/test/ui/administration/elements/ProfileUserProfilePage.java
===================================================================
--- ui-tests/src/test/it/org/xwiki/test/ui/administration/elements/ProfileUserProfilePage.java	(revision 34205)
+++ ui-tests/src/test/it/org/xwiki/test/ui/administration/elements/ProfileUserProfilePage.java	(working copy)
@@ -27,7 +27,7 @@
 
 /**
  * Represents the User Profile Profile Tab.
- *
+ * 
  * @version $Id$
  */
 public class ProfileUserProfilePage extends AbstractUserProfilePage
@@ -138,7 +138,7 @@
 
     public String getAvatarImageName()
     {
-        return StringUtils.substringBefore(StringUtils.substringAfterLast(
-            this.userAvatarImage.getAttribute("src"), "/"), "?");
+        return StringUtils.substringBefore(
+            StringUtils.substringAfterLast(this.userAvatarImage.getAttribute("src"), "/"), "?");
     }
 }
Index: ui-tests/src/test/it/org/xwiki/test/ui/CopyPageTest.java
===================================================================
--- ui-tests/src/test/it/org/xwiki/test/ui/CopyPageTest.java	(revision 0)
+++ ui-tests/src/test/it/org/xwiki/test/ui/CopyPageTest.java	(revision 0)
@@ -0,0 +1,85 @@
+/*
+ * See the NOTICE file distributed with this work for additional
+ * information regarding copyright ownership.
+ *
+ * This is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU Lesser General Public License as
+ * published by the Free Software Foundation; either version 2.1 of
+ * the License, or (at your option) any later version.
+ *
+ * This software is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this software; if not, write to the Free
+ * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
+ * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
+ */
+package org.xwiki.test.ui;
+
+import junit.framework.Assert;
+
+import org.junit.Test;
+import org.xwiki.test.ui.framework.AbstractAdminAuthenticatedTest;
+import org.xwiki.test.ui.framework.elements.CopyPage;
+import org.xwiki.test.ui.framework.elements.CopyPageConfirmation;
+import org.xwiki.test.ui.framework.elements.ViewPage;
+import org.xwiki.test.ui.framework.elements.editor.WikiEditPage;
+import org.xwiki.test.ui.xe.elements.HomePage;
+
+/**
+ * @version $Id$
+ * @since 3.0M2
+ */
+public class CopyPageTest extends AbstractAdminAuthenticatedTest
+{
+
+    private HomePage homePage;
+
+    private static final String SPACE_VALUE = "Main";
+
+    private static final String PAGE_VALUE = "CopyPageTest";
+
+    private static final String SPACE_VALUE_COPY = "Main";
+
+    private static final String PAGE_VALUE_COPY = "CopyPageTest1";
+
+    private static final String PAGE_CONTENT = "This page is used for copying purposes";
+
+    private static final String PAGE_TITLE = "Page title that will be copied";
+
+    private static final String COPY_SUCCESSFUL = "successfully copied to";
+
+    public void setUp()
+    {
+        // Delete page is already exists
+        super.setUp();
+        getUtil().deletePage(SPACE_VALUE, PAGE_VALUE);
+        getUtil().deletePage(SPACE_VALUE_COPY, PAGE_VALUE_COPY);
+        homePage = new HomePage();
+        homePage.gotoPage();
+    }
+
+    @Test
+    public void testCopyPage()
+    {
+        // Create a new Page that will be copied
+        WikiEditPage wep = new WikiEditPage();
+        wep.switchToEdit(SPACE_VALUE, PAGE_VALUE);
+        wep.setTitle(PAGE_TITLE);
+        wep.setContent(PAGE_CONTENT);
+        ViewPage viewPage = wep.clickSaveAndView();
+        viewPage.waitUntilPageIsLoaded();
+        // Click on Copy Page from Top Menu
+        CopyPage copyPage = viewPage.copyCurrentPage();
+        // Fill the Target destination of the page to be copied to
+        copyPage.setTargetPlace(SPACE_VALUE_COPY + "." + PAGE_VALUE_COPY);
+        CopyPageConfirmation copyPageConfirmation = copyPage.clickCopyButton();
+        Assert.assertTrue(copyPageConfirmation.getInfoMessage().contains(COPY_SUCCESSFUL));
+        viewPage = copyPageConfirmation.goToNewPage();
+        Assert.assertEquals(PAGE_TITLE, viewPage.getDocumentTitle());
+        Assert.assertEquals(PAGE_CONTENT, viewPage.getContent());
+    }
+}
Index: ui-tests/src/test/it/org/xwiki/test/ui/framework/elements/ViewPage.java
===================================================================
--- ui-tests/src/test/it/org/xwiki/test/ui/framework/elements/ViewPage.java	(revision 34205)
+++ ui-tests/src/test/it/org/xwiki/test/ui/framework/elements/ViewPage.java	(working copy)
@@ -37,16 +37,16 @@
  */
 public class ViewPage extends BasePage
 {
-    @FindBys( {@FindBy(id = "tmRegister"), @FindBy(tagName = "a")})
+    @FindBys({@FindBy(id = "tmRegister"), @FindBy(tagName = "a")})
     private WebElement registerLink;
 
-    @FindBys( {@FindBy(id = "tmLogin"), @FindBy(tagName = "a")})
+    @FindBys({@FindBy(id = "tmLogin"), @FindBy(tagName = "a")})
     private WebElement loginLink;
 
-    @FindBys( {@FindBy(id = "tmLogout"), @FindBy(tagName = "a")})
+    @FindBys({@FindBy(id = "tmLogout"), @FindBy(tagName = "a")})
     private WebElement logoutLink;
 
-    @FindBys( {@FindBy(id = "tmUser"), @FindBy(tagName = "a")})
+    @FindBys({@FindBy(id = "tmUser"), @FindBy(tagName = "a")})
     private WebElement userLink;
 
     @FindBy(id = "tmCreatePage")
@@ -64,6 +64,12 @@
     @FindBy(id = "hierarchy")
     private WebElement hierarchy;
 
+    @FindBy(id = "tmActionCopy")
+    private WebElement copyPageLink;
+
+    @FindBy(id = "document-title")
+    private WebElement documentTitle;
+
     /**
      * Logs in the Admin user (move to the home page if the current page has no log in link).
      */
@@ -221,13 +227,15 @@
 
     /**
      * Clicks on a wanted link in the page.
-     *
+     * 
      * @since 2.6RC1
      */
     public void clickWantedLink(String spaceName, String pageName, boolean waitForTemplateDisplay)
     {
-        WebElement brokenLink = getDriver().findElement(By.xpath(
-            "//span[@class='wikicreatelink']/a[contains(@href,'/create/" + spaceName + "/" + pageName + "')]"));
+        WebElement brokenLink =
+            getDriver().findElement(
+                By.xpath("//span[@class='wikicreatelink']/a[contains(@href,'/create/" + spaceName + "/" + pageName
+                    + "')]"));
         brokenLink.click();
         if (waitForTemplateDisplay) {
             // Ensure that the template choice popup is displayed. Since this is done using JS we need to wait till
@@ -236,4 +244,16 @@
             waitUntilElementIsVisible(By.xpath("//div[@class='modal-popup']//input[@type='submit']"));
         }
     }
+
+    public CopyPage copyCurrentPage()
+    {
+        hoverOverMenu("tmPage");
+        this.copyPageLink.click();
+        return new CopyPage();
+    }
+
+    public String getDocumentTitle()
+    {
+        return this.documentTitle.getText();
+    }
 }
Index: ui-tests/src/test/it/org/xwiki/test/ui/framework/elements/CopyPage.java
===================================================================
--- ui-tests/src/test/it/org/xwiki/test/ui/framework/elements/CopyPage.java	(revision 0)
+++ ui-tests/src/test/it/org/xwiki/test/ui/framework/elements/CopyPage.java	(revision 0)
@@ -0,0 +1,50 @@
+/*
+ * See the NOTICE file distributed with this work for additional
+ * information regarding copyright ownership.
+ *
+ * This is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU Lesser General Public License as
+ * published by the Free Software Foundation; either version 2.1 of
+ * the License, or (at your option) any later version.
+ *
+ * This software is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this software; if not, write to the Free
+ * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
+ * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
+ */
+package org.xwiki.test.ui.framework.elements;
+
+import org.openqa.selenium.WebElement;
+import org.openqa.selenium.support.FindBy;
+
+/**
+ * Represents the common actions possible on the Copy Page page.
+ * 
+ * @version $Id$
+ * @since 3.0M2
+ */
+public class CopyPage extends ViewPage
+{
+    // input[@id='targetdoc']
+    @FindBy(id = "targetdoc")
+    private WebElement targetPlace;
+
+    @FindBy(xpath = "//span[@class='buttonwrapper']/input[@class='button']")
+    private WebElement copyButton;
+
+    public void setTargetPlace(String targetPlace)
+    {
+        this.targetPlace.sendKeys(targetPlace);
+    }
+
+    public CopyPageConfirmation clickCopyButton()
+    {
+        this.copyButton.submit();
+        return new CopyPageConfirmation();
+    }
+}
Index: ui-tests/src/test/it/org/xwiki/test/ui/framework/elements/CopyPageConfirmation.java
===================================================================
--- ui-tests/src/test/it/org/xwiki/test/ui/framework/elements/CopyPageConfirmation.java	(revision 0)
+++ ui-tests/src/test/it/org/xwiki/test/ui/framework/elements/CopyPageConfirmation.java	(revision 0)
@@ -0,0 +1,59 @@
+/*
+ * See the NOTICE file distributed with this work for additional
+ * information regarding copyright ownership.
+ *
+ * This is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU Lesser General Public License as
+ * published by the Free Software Foundation; either version 2.1 of
+ * the License, or (at your option) any later version.
+ *
+ * This software is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this software; if not, write to the Free
+ * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
+ * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
+ */
+package org.xwiki.test.ui.framework.elements;
+
+import org.openqa.selenium.WebElement;
+import org.openqa.selenium.support.FindBy;
+
+/**
+ * Represents the common actions possible after a Page has been copied.
+ * 
+ * @version $Id$
+ * @since 3.0M2
+ */
+public class CopyPageConfirmation extends ViewPage
+{
+
+    @FindBy(xpath = "//div[@class='infomessage']/a[1]")
+    private WebElement oldPage;
+
+    @FindBy(xpath = "//div[@class='infomessage']/a[2]")
+    private WebElement newPage;
+
+    @FindBy(className = "infomessage")
+    private WebElement infoMessage;
+
+    public ViewPage goToOriginalPage()
+    {
+        this.oldPage.click();
+        return new ViewPage();
+    }
+
+    public ViewPage goToNewPage()
+    {
+        this.newPage.click();
+        return new ViewPage();
+    }
+
+    public String getInfoMessage()
+    {
+        return this.infoMessage.getText();
+    }
+}